//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Lime
#property indicator_width1 0.3
#property indicator_width2 0.3

//
//
//
//
//

extern double x1              = 80;
extern double x2              = 20;
extern int    WprPrice        = 0; 
extern int    Risk            = 1;
extern double ArrowsGap       = 1.0;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = true;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double arrDn[];
double arrUp[];
double wpr[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,arrDn); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,234);
   SetIndexBuffer(1,arrUp); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,233);
   SetIndexBuffer(2,wpr);
   SetIndexBuffer(3,trend);
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   x1 = x1 + Risk;
   x2 = x2 - Risk;
   for (int i=limit; i>=0 ; i--)
   {
      int    period = 3 + Risk * 2;
      double range  = 0; for (int k = 0; k < 10; k++) range += High[i+k] - Low[i+k]; range /= 10.0;
      bool   found1 = false; for (k = 0; k < 6 && !found1; k++) found1 = (MathAbs(Open[i+k]    - Close[i+k+1])>= range * 2.0);
      bool   found2 = false; for (k = 0; k < 9 && !found2; k++) found2 = (MathAbs(Close[i+k+3] - Close[i+k])  >= range * 4.6);
             if (found1) period = 3;
             if (found2) period = 4;
             double price = iMA(NULL,0,1,0,MODE_SMA,WprPrice,i); 
             double hi    = High[Highest(NULL, 0, MODE_HIGH,period,i)];
             double lo    = Low[Lowest(NULL,   0, MODE_LOW, period,i)];
             if (hi!=lo)      
                  wpr[i]  = 100+(-100)*(hi - price) / (hi - lo);
             else wpr[i]  = 0;  
                trend[i]  = trend[i+1]; 

      //
      //
      //
      //
      //
               
      arrDn[i] = EMPTY_VALUE;
      arrUp[i] = EMPTY_VALUE;
         if (wpr[i] < x2) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]>x1) arrDn[i] = High[i] + range * ArrowsGap; trend[i] = -1;}
         if (wpr[i] > x1) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]<x2) arrUp[i] = Low[i]  - range * ArrowsGap; trend[i] =  1;}
   }
   
   //
   //
   //
   //
   //
               
   if (alertsOn)
   {
   if (alertsOnCurrent)
        int whichBar = 0;
   else     whichBar = 1;

   //
   //
   //
   //
   //
         
   if (trend[whichBar] != trend[whichBar+1])
   if (trend[whichBar] == 1)
         doAlert("buy");
   else  doAlert("sell");  
        
   }
return(0);           
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Trend signal ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Trend signal "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

